/*
** ADM-XRC Series Driver
**
** (C) Copyright 2001-2004 Alpha Data
**
** drvparam.c - Retrieves the driver parameters and saves them in a globally
**              visible structure, for easy access.
**
** ----------------------------------------------------------------------------
*/

#include "device.h"
#include "drvparam.h"

void
admxrcInitDriverParams(
  OS_DRIVER_OBJECT* pDrvObj)
{
  admxrcDriverParams.pciReadMultiple = FALSE;
  admxrcDriverParams.pciWriteAndInvalidate = FALSE;
  admxrcDriverParams.maxDmaDesc = ADMXRC_MAX_DMADESC;
  admxrcDriverParams.maxPlxDesc = ADMXRC_MAX_PLXDESC_PER_CHANNEL;
  admxrcDriverParams.pci9656ErrataFix = FALSE;
  admxrcDriverParams.pci9656RegsAsSpace = FALSE;
  admxrcDriverParams.pci9656DmaDisable = FALSE;
  admxrcDriverParams.icd2061PMax = 131;
  admxrcDriverParams.model.xrc.lclkMin = 399000;
  admxrcDriverParams.model.xrc.lclkMax = 40001000;
  admxrcDriverParams.model.xrcp.lclkMin = 399000;
  admxrcDriverParams.model.xrcp.lclkMax = 40001000;
  admxrcDriverParams.model.xrc2l.lclkMin = 399000;
  admxrcDriverParams.model.xrc2l.lclkMax = 40001000;
  admxrcDriverParams.model.xrc2.lclkMin = 399000;
  admxrcDriverParams.model.xrc2.lclkMax = 66001000;
  admxrcDriverParams.model.xrc2pl.lclkMin = 59999000;
  admxrcDriverParams.model.xrc2pl.lclkMax = 80001000;
  admxrcDriverParams.model.xrc2pl.unlockFlash = FALSE;
  admxrcDriverParams.model.wrc2.lclkMin = 399000;
  admxrcDriverParams.model.wrc2.lclkMax = 66001000;
  admxrcDriverParams.model.drc2.lclkMin = 399000;
  admxrcDriverParams.model.drc2.lclkMax = 66001000;
  admxrcDriverParams.model.xrc2p.lclkMin = 5999000;
  admxrcDriverParams.model.xrc2p.lclkMax = 80001000;
  admxrcDriverParams.model.xrc2p.unlockFlash = FALSE;
  admxrcDriverParams.model.xpi.lclkMin = 5999000;
  admxrcDriverParams.model.xpi.lclkMax = 80001000;
  admxrcDriverParams.model.xpi.unlockFlash = FALSE;
  admxrcDriverParams.model.xrc4ls.lclkMin = 399000;
  admxrcDriverParams.model.xrc4ls.lclkMax = 66001000;
  admxrcDriverParams.model.xrc4ls.smap32Bit = FALSE;
  admxrcDriverParams.model.xrc4lx.lclkMin = 399000;
  admxrcDriverParams.model.xrc4lx.lclkMax = 66001000;
  admxrcDriverParams.model.xrc4ls.smap32Bit = FALSE;
  admxrcDriverParams.model.xrc4sx.lclkMin = 399000;
  admxrcDriverParams.model.xrc4sx.lclkMax = 66001000;
  admxrcDriverParams.model.xrc4ls.smap32Bit = FALSE;
  
  os_get_driver_param(pDrvObj,
		      "PCIReadMultiple",
		      DriverParamType_boolean,
		      &admxrcDriverParams.pciReadMultiple,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "PCIWriteAndInvalidate",
		      DriverParamType_boolean,
		      &admxrcDriverParams.pciWriteAndInvalidate,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "PCI9656DmaDisable",
		      DriverParamType_boolean,
		      &admxrcDriverParams.pci9656DmaDisable,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "PCI9656ErrataFix",
		      DriverParamType_boolean,
		      &admxrcDriverParams.pci9656ErrataFix,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "PCI9656RegsAsSpace",
		      DriverParamType_boolean,
		      &admxrcDriverParams.pci9656RegsAsSpace,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "MaxDmaDesc",
		      DriverParamType_uint32,
		      &admxrcDriverParams.maxDmaDesc,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "MaxPlxDesc",
		      DriverParamType_uint32,
		      &admxrcDriverParams.maxPlxDesc,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ICD2061PMax",
		      DriverParamType_uint32,
		      &admxrcDriverParams.icd2061PMax,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRCMaxLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.xrc.lclkMax,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRCMinLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.xrc.lclkMin,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRCPMaxLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.xrcp.lclkMax,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRCPMinLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.xrcp.lclkMin,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRC2LMaxLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.xrc2l.lclkMax,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRC2LMinLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.xrc2l.lclkMin,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRC2MaxLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.xrc2.lclkMax,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRC2MinLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.xrc2.lclkMin,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRC2PLMaxLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.xrc2pl.lclkMax,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRC2PLMinLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.xrc2pl.lclkMin,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRC2PLUnlockFlash",
		      DriverParamType_boolean,
		      &admxrcDriverParams.model.xrc2pl.unlockFlash,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRC2PMaxLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.xrc2p.lclkMax,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRC2PMinLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.xrc2p.lclkMin,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRC2PUnlockFlash",
		      DriverParamType_boolean,
		      &admxrcDriverParams.model.xrc2p.unlockFlash,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADPDRC2MaxLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.drc2.lclkMax,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADPDRC2MinLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.drc2.lclkMin,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADPWRC2MaxLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.wrc2.lclkMax,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADPWRC2MinLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.wrc2.lclkMin,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADPXPIMaxLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.xpi.lclkMax,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADPXPIMinLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.xpi.lclkMin,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADPXPIUnlockFlash",
		      DriverParamType_boolean,
		      &admxrcDriverParams.model.xpi.unlockFlash,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRC4LSMaxLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.xrc4ls.lclkMax,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRC4LSMinLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.xrc4ls.lclkMin,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRC4LSSmap32Bit",
		      DriverParamType_boolean,
		      &admxrcDriverParams.model.xrc4ls.smap32Bit,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRC4LXMaxLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.xrc4lx.lclkMax,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRC4LXMinLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.xrc4lx.lclkMin,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRC4LXSmap32Bit",
		      DriverParamType_boolean,
		      &admxrcDriverParams.model.xrc4lx.smap32Bit,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRC4SXMaxLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.xrc4sx.lclkMax,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRC4SXMinLCLK",
		      DriverParamType_uint32,
		      &admxrcDriverParams.model.xrc4sx.lclkMin,
		      sizeof(os_uint32));

  os_get_driver_param(pDrvObj,
		      "ADMXRC4SXSmap32Bit",
		      DriverParamType_boolean,
		      &admxrcDriverParams.model.xrc4sx.smap32Bit,
		      sizeof(os_uint32));

  os_dbgprint(2, ("admxrcInitDriverParams:\n"));
  os_dbgprint(2, ("  PCIReadMultiple=%ld\n", (unsigned long) admxrcDriverParams.pciReadMultiple));
  os_dbgprint(2, ("  PCIWriteAndInvalidate=%ld\n", (unsigned long) admxrcDriverParams.pciWriteAndInvalidate));
  os_dbgprint(2, ("  PCI9656ErrataFix=%ld\n", (unsigned long) admxrcDriverParams.pci9656ErrataFix));
  os_dbgprint(2, ("  PCI9656RegsAsSpace=%ld\n", (unsigned long) admxrcDriverParams.pci9656RegsAsSpace));
  os_dbgprint(2, ("  PCI9656DmaDisable=%ld\n", (unsigned long) admxrcDriverParams.pci9656DmaDisable));
  os_dbgprint(2, ("  MaxDmaDesc=%ld\n", (unsigned long) admxrcDriverParams.maxDmaDesc));
  os_dbgprint(2, ("  MaxPlxDesc=%ld\n", (unsigned long) admxrcDriverParams.maxPlxDesc));
  os_dbgprint(2, ("  ICD2061PMax=%ld\n", (unsigned long) admxrcDriverParams.icd2061PMax));
  os_dbgprint(2, ("  ADMXRCMaxLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.xrc.lclkMax));
  os_dbgprint(2, ("  ADMXRCMinLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.xrc.lclkMin));
  os_dbgprint(2, ("  ADMXRCPMaxLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.xrcp.lclkMax));
  os_dbgprint(2, ("  ADMXRCPMinLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.xrcp.lclkMin));
  os_dbgprint(2, ("  ADMXRC2LMaxLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.xrc2l.lclkMax));
  os_dbgprint(2, ("  ADMXRC2LMinLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.xrc2l.lclkMin));
  os_dbgprint(2, ("  ADMXRC2MaxLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.xrc2.lclkMax));
  os_dbgprint(2, ("  ADMXRC2MinLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.xrc2.lclkMin));
  os_dbgprint(2, ("  ADMXRC2PLMaxLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.xrc2pl.lclkMax));
  os_dbgprint(2, ("  ADMXRC2PLMinLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.xrc2pl.lclkMin));
  os_dbgprint(2, ("  ADMXRC2PLUnlockFlash=%ld\n", (unsigned long) admxrcDriverParams.model.xrc2pl.unlockFlash));
  os_dbgprint(2, ("  ADMXRC2PMaxLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.xrc2p.lclkMax));
  os_dbgprint(2, ("  ADMXRC2PMinLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.xrc2p.lclkMin));
  os_dbgprint(2, ("  ADMXRC2PUnlockFlash=%ld\n", (unsigned long) admxrcDriverParams.model.xrc2p.unlockFlash));
  os_dbgprint(2, ("  ADPDRC2MaxLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.drc2.lclkMax));
  os_dbgprint(2, ("  ADPDRC2MinLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.drc2.lclkMin));
  os_dbgprint(2, ("  ADPWRC2MaxLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.wrc2.lclkMax));
  os_dbgprint(2, ("  ADPWRC2MinLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.wrc2.lclkMin));
  os_dbgprint(2, ("  ADPXPIMaxLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.xpi.lclkMax));
  os_dbgprint(2, ("  ADPXPIMinLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.xpi.lclkMin));
  os_dbgprint(2, ("  ADPXPIUnlockFlash=%ld\n", (unsigned long) admxrcDriverParams.model.xpi.unlockFlash));
  os_dbgprint(2, ("  ADMXRC4LSMaxLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.xrc4ls.lclkMax));
  os_dbgprint(2, ("  ADMXRC4LSMinLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.xrc4ls.lclkMin));
  os_dbgprint(2, ("  ADMXRC4LSSmap32Bit=%ld\n", (unsigned long) admxrcDriverParams.model.xrc4ls.smap32Bit));
  os_dbgprint(2, ("  ADMXRC4LXMaxLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.xrc4lx.lclkMax));
  os_dbgprint(2, ("  ADMXRC4LXMinLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.xrc4lx.lclkMin));
  os_dbgprint(2, ("  ADMXRC4LXSmap32Bit=%ld\n", (unsigned long) admxrcDriverParams.model.xrc4lx.smap32Bit));
  os_dbgprint(2, ("  ADMXRC4SXMaxLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.xrc4sx.lclkMax));
  os_dbgprint(2, ("  ADMXRC4SXMinLCLK=%ld\n", (unsigned long) admxrcDriverParams.model.xrc4sx.lclkMin));
  os_dbgprint(2, ("  ADMXRC4SXSmap32Bit=%ld\n", (unsigned long) admxrcDriverParams.model.xrc4sx.smap32Bit));
}
